local InSideAB = false;
local Ticks = {Horde = 10,Alli = 10};
local TimeRemaining = {Horde = 0,Alli = 0};
local Bases = {Horde = 0,Alli = 0};
local Resources = {Horde = 0,Alli = 0};
local TickIn = {Horde = 11,Alli = 11};
local TickLength = {Horde = 11, Alli = 11};
local timePassed = 0;
local Pos = {
        {Owner = -1, Capper = -1},
        {Owner = -1, Capper = -1},
        {Owner = -1, Capper = -1},
        {Owner = -1, Capper = -1},
        {Owner = -1, Capper = -1}
        };
local capsIn = {0,0,0,0,0};

--0 == horde 1 == alli

function ResourceBars_OnLoad()
	this:RegisterForDrag("LeftButton");
    this:RegisterEvent("ZONE_CHANGED_NEW_AREA");
    this:RegisterEvent("ZONE_CHANGED");
    this:RegisterEvent("ZONE_CHANGED_INDOORS");
    this:RegisterEvent("PLAYER_ENTERING_WORLD");
    this:RegisterEvent("CHAT_MSG_BG_SYSTEM_ALLIANCE");
    this:RegisterEvent("CHAT_MSG_BG_SYSTEM_HORDE");
    this:RegisterEvent("CHAT_MSG_BG_SYSTEM_NEUTRAL");
    
    ResourceBars:Hide();
end

function ResourceBars_OnDragStart()
	ResourceBars:StartMoving()
end

function ResourceBars_OnDragStop()
	ResourceBars:StopMovingOrSizing()
end

function GetCurrentScoreBases(arg1)
    local i;
    local AlliB, HordeB = 0,0;
    for i = 1, 5 do
        local name, state, typ, x, y = GetMapLandmarkInfo(i);
        
        if (state == "In Conflict") then
            if (Pos[i].Owner ==  1) then
                Pos[i].Capper = 0;
            elseif(Pos[i].Owner == 0) then
                Pos[i].Capper = 1;
            end
            capsIn[i]=math.floor(GetTime(),0)
        elseif(state == "Alliance Controlled")then
            Pos[i].Owner = 1;
            AlliB = AlliB + 1;
        elseif(state == "Horde Controlled")then
            Pos[i].Owner = 0;
            HordeB = HordeB + 1;
        end
    end

    Bases.Horde = HordeB;
    Bases.Alli = AlliB;
    
    UpdateScore(arg1);
    SetTicks();
    
    if(HordeTick:GetValue() > Ticks.Horde) then
        HordeTick:SetValue(Ticks.Horde);
    end
            
    if(AlliTick:GetValue() > Ticks.Alli) then
        AlliTick:SetValue(Ticks.Alli);
    end
    --UIErrorsFrame:AddMessage(HordeB, 1.0, 0.0, 0.0, 1.0, 2.0);
    --UIErrorsFrame:AddMessage(AlliB, 0.0, 1.0, 1.0, 1.0, 2.0);
end

function ABR_Event(event, arg1)
    --UIErrorsFrame:AddMessage(GetRealZoneText(), 1.0, 0.0, 0.0, 1.0, 2.0);

    if (GetRealZoneText() == "Arathi Basin") then
        ResourceBars:Show();
        GetCurrentScoreBases(arg1);

    else
        ResourceBars:Hide();
        local TimeRemaining = {Horde = 0,Alli = 0};
        local Bases = {Horde = 0,Alli = 0};
        local Resources = {Horde = 0,Alli = 0};
        local TickIn = {Horde = 11,Alli = 11};
        local TickLength = {Horde = 11, Alli = 11};
        local timePassed = 0;
        HordeScore:SetText("0/2000");
        AlliScore:SetText("0/2000");
    end
end

function UpdateScore(arg1)
    local _,ally=GetWorldStateUIInfo(1);
    local _,horde=GetWorldStateUIInfo(2);
    if (horde and ally) then
        _, _, strAlliBases, strAlliScore = string.find(ally, "Bases: (%d+)  Resources: (%d+)/2000");
        _, _, strHordeBases, strHordeScore = string.find(horde, "Bases: (%d+)  Resources: (%d+)/2000");
    end
    local tempH,tempA = tonumber(strHordeScore),tonumber(strAlliScore)
    
    if(Resources.Alli <  tempA)then
        AlliTick:SetValue(TickLength.Alli);
        AlliTickTime:SetText(TickLength.Alli);
        TickIn.Alli = TickLength.Alli;
        Resources.Alli = tempA;
        
        TimeRemaining.Alli = ((2000 - Resources.Alli)/Ticks.Alli) * TickLength.Alli;
        AlliScore:SetText(format(TEXT(Resources.Alli)) .. "/2000");
        AlliResource:SetValue(Resources.Alli);
    elseif(Resources.Alli >  tempA)then
        Resources.Alli = tempA;
        
        TimeRemaining.Alli = ((2000 - Resources.Alli)/Ticks.Alli) * TickLength.Alli;
        AlliScore:SetText(format(TEXT(Resources.Alli)) .. "/2000");
        AlliResource:SetValue(Resources.Alli);
    end
    
    if(Resources.Horde <  tempH)then
        HordeTick:SetValue(TickLength.Horde);
        HordeTickTime:SetText(TickLength.Horde);
        TickIn.Horde = TickLength.Horde;
        Resources.Horde = tempH;
        
        TimeRemaining.Horde = ((2000 - Resources.Horde)/Ticks.Horde) * TickLength.Horde;
        HordeScore:SetText(format(TEXT(Resources.Horde)) .. "/2000");
        HordeResource:SetValue(Resources.Horde);
        
    elseif(Resources.Horde > tempH)then
        Resources.Horde = tempH;
        
        TimeRemaining.Horde = ((2000 - Resources.Horde)/Ticks.Horde) * TickLength.Horde;
        HordeScore:SetText(format(TEXT(Resources.Horde)) .. "/2000");
        HordeResource:SetValue(Resources.Horde);
    end
    
    --UIErrorsFrame:AddMessage(strAllyBases, 1.0, 0.0, 0.0, 1.0, 2.0);

end

function Update_Ticks(arg1)

    AlwaysUpFrame1:Hide();
    AlwaysUpFrame2:Hide();
    
    HordeTick:SetValue((TickIn.Horde - timePassed) + 1);
    HordeTickTime:SetText(format(TEXT(TickIn.Horde + 1)));
    
    AlliTick:SetValue((TickIn.Alli - timePassed) + 1);
    AlliTickTime:SetText(format(TEXT(TickIn.Alli + 1)));

    if(timePassed > 1) then
        UpdateScore(arg1);
        HordeTTW:SetText(SSLibrary_SecondsToBuff(TimeRemaining.Horde));
        AlliTTW:SetText(SSLibrary_SecondsToBuff(TimeRemaining.Alli));
        
        if(TimeRemaining.Horde > 0) then
            TimeRemaining.Horde = TimeRemaining.Horde - 1;
        end
        
        if(TimeRemaining.Alli > 0) then
            TimeRemaining.Alli = TimeRemaining.Alli - 1;
        end
        
        if(TickIn.Horde == 0) then
            Resources.Horde = Resources.Horde + Ticks.Horde;
            TimeRemaining.Horde = ((2000 - Resources.Horde)/Ticks.Horde) * TickLength.Horde;
            
            HordeScore:SetText(format(TEXT(Resources.Horde)) .. "/2000");
            HordeResource:SetValue(Resources.Horde);
            
            TickIn.Horde = TickLength.Horde;
        end
        
        if(TickIn.Alli == 0) then 
            Resources.Alli = Resources.Alli + Ticks.Alli;
            TimeRemaining.Alli = ((2000 - Resources.Alli)/Ticks.Alli) * TickLength.Alli;
            
            AlliScore:SetText(format(TEXT(Resources.Alli)) .. "/2000");
            AlliResource:SetValue(Resources.Alli);
            
            TickIn.Alli = TickLength.Alli;
        end
    
        if(Resources.Horde > 2001) then
            Resources.Horde = 0;
        end
    
        if(Resources.Alli > 2001) then
            Resources.Alli = 0;
        end
        TickIn.Horde = TickIn.Horde - 1;
        TickIn.Alli = TickIn.Alli - 1;
        timePassed = timePassed - 1; 
    end
    timePassed = timePassed + arg1;
end

function SetTicks()
    if(Bases.Horde == 0) then
        Ticks.Horde = 0;
        TickLength.Horde = 0;
        HordeTick:SetMinMaxValues(0,0);
    elseif(Bases.Horde == 1)then
        Ticks.Horde = 10;
        TickLength.Horde = 12;
        HordeTick:SetMinMaxValues(0,12);
    elseif(Bases.Horde == 2)then
        Ticks.Horde = 10;
        TickLength.Horde = 9;
        HordeTick:SetMinMaxValues(0,9);
    elseif(Bases.Horde == 3)then
        Ticks.Horde = 10;
        TickLength.Horde = 6;
        HordeTick:SetMinMaxValues(0,6);
    elseif(Bases.Horde == 4)then
        Ticks.Horde = 10;
        TickLength.Horde = 3;
        HordeTick:SetMinMaxValues(0,3);
    elseif(Bases.Horde == 5)then
        Ticks.Horde = 30;
        TickLength.Horde = 1;
        HordeTick:SetMinMaxValues(0,1);
    end

    if(Bases.Alli == 0) then
        Ticks.Alli = 0;
        TickLength.Alli = 0;
        AlliTick:SetMinMaxValues(0,0);    
    elseif(Bases.Alli == 1)then
        Ticks.Alli = 10;
        TickLength.Alli = 12;
        AlliTick:SetMinMaxValues(0,11);
    elseif(Bases.Alli == 2)then
        Ticks.Alli = 10;
        TickLength.Alli = 9;
        AlliTick:SetMinMaxValues(0,9);
    elseif(Bases.Alli == 3)then
        Ticks.Alli = 10;
        TickLength.Alli = 6;
        AlliTick:SetMinMaxValues(0,6);
    elseif(Bases.Alli == 4)then
        Ticks.Alli = 10;
        TickLength.Alli = 3;
        AlliTick:SetMinMaxValues(0,3);
    elseif(Bases.Alli == 5)then
        Ticks.Alli = 30;
        TickLength.Alli = 1;
        AlliTick:SetMinMaxValues(0,1);
    end
    
    HordeTick:SetValue(TickLength.Horde);
    AlliTick:SetValue(TickLength.Alli);
end

function SSLibrary_SecondsToBuff( seconds )
	seconds = floor( seconds );
	local hours, minutes;
	
	if( seconds >= 3600 ) then
		hours = floor( seconds / 3600 );
		if( hours <= 9 ) then
			hours = "0" .. hours; 
		end
		
		hours = hours .. ":";
		seconds = mod( seconds, 3600 );
	else
		hours = "";
	end
	
	if( seconds >= 60 ) then
		minutes = floor( seconds / 60 );
		if( minutes <= 9 ) then
			minutes = "0" .. minutes;
		end
		
		seconds = mod( seconds, 60 );
	else
		minutes = "00";
	end
	
	if( seconds <= 9 and seconds > 0 ) then
		seconds = "0" .. seconds;
	elseif( seconds <= 0 ) then
		seconds = "00";
	end
	
	return hours .. minutes .. ":" .. seconds;
end